<?php
//
// Copyright (c) 2008-2009 Nagios Enterprises, LLC.  All rights reserved.
//  
// $Id: db.inc.php 130 2008-04-24 17:44:17Z egalstad $

require_once(dirname(__FILE__).'/../includes/common.inc.php');


// initialization stuff
pre_init();

// start session
init_session();

// grab GET or POST variables 
grab_request_vars();

// check prereqs
check_prereqs();

// check authentication
check_authentication();

route_request();

function route_request(){
	global $request;
	global $lstr;
	
	if(is_admin()==false){
		echo $lstr['NotAuthorizedErrorText'];
		exit();
		}
	
	draw_page();
	}

function draw_page(){
	global $lstr;
	
	$pageopt=grab_request_var("pageopt","");
	
	do_page_start(array("page_title"=>$lstr['AdminPageTitle']),false);
?>
	<div id="leftnav">
	<?php draw_menu();?>
	</div>

	<div id="maincontent">
	<div id="maincontentspacer">
	<IFRAME src="<?php echo get_window_frame_url("main.php");?>" width="100%" frameborder="0" id="maincontentframe" name="maincontentframe">
	[Your user agent does not support frames or is currently configured not to display frames. ]
	</IFRAME>
	
	<div id="viewtools">
	<div id="popout">
	<a href="#"><img src="<?php echo get_base_url();?>/images/popout.png" border="0" alt="<?php echo $lstr['PopoutAlt'];?>" title="<?php echo $lstr['PopoutAlt'];?>"></a>
	</div>
	</div>
	
	</div>
	</div>
	


<?	
	do_page_end(false);
	}

function draw_menu(){
	$m=get_menu_items();
	draw_menu_items($m);
?>

<?php
	}
	

function get_menu_items(){

	$base_url=get_base_url();
	$base_path=$base_url."admin/";
	
	
	$mi=array();
	
	// Quick
	$mi[]=array(
		"type" => "menusection",
		"title" => "Quick Tools",
		"opts" => array(
			"id" => "quickview",
			"expanded" => true,
			"url" => $base_path."main.php",
			)
		);
	$mi[]=array(
		"type" => "link",
		"title" => "Admin Home",
		"opts" => array(
			"href" => $base_path."main.php",
			)
		);
	$mi[]=array(
		"type" => "menusectionend",
		"title" => "",
		"opts" => ""
		);
				
	// System
	$mi[]=array(
		"type" => "menusection",
		"title" => "System Status",
		"opts" => array(
			"id" => "systemstatus",
			"expanded" => true,
			"url" => $base_path."sysstat.php",
			)
		);
	$mi[]=array(
		"type" => "link",
		"title" => "System Status",
		"opts" => array(
			"href" => $base_path."sysstat.php",
			)
		);
	$mi[]=array(
		"type" => "link",
		"title" => "Monitoring Engine Status",
		"opts" => array(
			"href" => $base_path."sysstat.php?pageopt=monitoringengine",
			)
		);
	$mi[]=array(
		"type" => "link",
		"title" => "Check For Updates",
		"opts" => array(
			"href" => $base_path."updates.php",
			)
		);
	$mi[]=array(
		"type" => "menusectionend",
		"title" => "",
		"opts" => ""
		);
		

	// Users
	$mi[]=array(
		"type" => "menusection",
		"title" => "Users",
		"opts" => array(
			"id" => "users",
			"expanded" => true,
			"url" => $base_path."users.php",
			)
		);
	$mi[]=array(
		"type" => "link",
		"title" => "Manage Users",
		"opts" => array(
			"href" => $base_path."users.php",
			)
		);
	$mi[]=array(
		"type" => "menusectionend",
		"title" => "",
		"opts" => ""
		);


	// System Configuration
	$mi[]=array(
		"type" => "menusection",
		"title" => "System Config",
		"opts" => array(
			"id" => "systemconfig",
			"expanded" => true,
			"url" => $base_path."globalconfig.php",
			)
		);
	$mi[]=array(
		"type" => "link",
		"title" => "Manage System Config",
		"opts" => array(
			"href" => $base_path."globalconfig.php",
			)
		);
	$mi[]=array(
		"type" => "link",
		"title" => "Manage Email Settings",
		"opts" => array(
			"href" => $base_path."mailsettings.php",
			)
		);
	$mi[]=array(
		"type" => "link",
		"title" => "Reset Security Credentials",
		"opts" => array(
			"href" => $base_path."credentials.php",
			)
		);
	$mi[]=array(
		"type" => "link",
		"title" => "License Information",
		"opts" => array(
			"href" => $base_path."license.php",
			)
		);
	$mi[]=array(
		"type" => "menusectionend",
		"title" => "",
		"opts" => ""
		);

		
	// Monitoring Configuration
	$mi[]=array(
		"type" => "menusection",
		"title" => "Monitoring Config",
		"opts" => array(
			"id" => "monitoringconfig",
			"expanded" => true,
			"url" => $base_path."coreconfigsnapshots.php",
			)
		);
	$mi[]=array(
		"type" => "link",
		"title" => "Config Snapshots",
		"opts" => array(
			"href" => $base_path."coreconfigsnapshots.php",
			)
		);
	$mi[]=array(
		"type" => "link",
		"title" => "Manage Plugins",
		"opts" => array(
			"href" => $base_path."monitoringplugins.php",
			)
		);
	$mi[]=array(
		"type" => "linkspacer",
		);

	$mi[]=array(
		"type" => "link",
		"title" => "Core Config Manager",
		"opts" => array(
			"img" => theme_image("menuredirect.png"),
			"href" => $base_url."config/nagioscorecfg/",
			"target" => "_self",
			)
		);
	$mi[]=array(
		"type" => "menusectionend",
		"title" => "",
		"opts" => ""
		);

		
	// System Extensions
	$mi[]=array(
		"type" => "menusection",
		"title" => "System Extensions",
		"opts" => array(
			"id" => "systemextensions",
			"expanded" => true,
			//"url" => $base_path.".php",
			)
		);
	$mi[]=array(
		"type" => "link",
		"title" => "Manage Components",
		"opts" => array(
			"href" => $base_path."components.php",
			)
		);
	$mi[]=array(
		"type" => "link",
		"title" => "Manage Dashlets",
		"opts" => array(
			"href" => $base_path."dashlets.php",
			)
		);
	$mi[]=array(
		"type" => "link",
		"title" => "Manage Config Wizards",
		"opts" => array(
			"href" => $base_path."configwizards.php",
			)
		);
	$mi[]=array(
		"type" => "menusectionend",
		"title" => "",
		"opts" => ""
		);

		
	// Audit Log
	/*
	$mi[]=array(
		"type" => "menusection",
		"title" => "Auditing",
		"opts" => array(
			"id" => "auditing",
			"expanded" => false,
			"url" => $base_path."auditlog.php",
			)
		);
	$mi[]=array(
		"type" => "link",
		"title" => "Audit Log",
		"opts" => array(
			"href" => $base_path."auditlog.php",
			)
		);
	$mi[]=array(
		"type" => "menusectionend",
		"title" => "",
		"opts" => ""
		);
	*/
		
	/*
	$mi[]=array(
		"type" => "link",
		"title" => "Components",
		"opts" => array(
			"href" => $page_path."?pageopt=managecomponents",
			)
		);
	$mi[]=array(
		"type" => "link",
		"title" => "Dashlets",
		"opts" => array(
			"href" => $page_path."?pageopt=managedashlets",
			)
		);
	$mi[]=array(
		"type" => "link",
		"title" => "Command Subsystem",
		"opts" => array(
			"href" => $page_path."?pageopt=managecommandsubsystem",
			)
		);
	$mi[]=array(
		"type" => "link",
		"title" => "Backup / Restore Config",
		"opts" => array(
			"href" => $page_path."?pageopt=backuprestore",
			)
		);
	$mi[]=array(
		"type" => "menusectionend",
		"title" => "",
		"opts" => ""
		);
	*/
				
				
				
				
	// Downloads
	/*
	$mi[]=array(
		"type" => "menusection",
		"title" => "Downloads",
		"opts" => array(
			"id" => "downloads",
			"expanded" => true,
			"url" => $page_path."?pageopt=downloads",
			)
		);
	$mi[]=array(
		"type" => "link",
		"title" => "Client Agents",
		"opts" => array(
			"href" => $page_path."?pageopt=downloads#agents",
			)
		);
	$mi[]=array(
		"type" => "menusectionend",
		"title" => "",
		"opts" => ""
		);
	*/
				
	return $mi;
	}
	

?>


